package com.usky.utils;

import com.dh.DpsdkCore.*;
import com.usky.entity.dh.TbDhNvrEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.FileOutputStream;
import java.io.IOException;

public class DPSDKUtil {
    private Logger logger = LoggerFactory.getLogger(DPSDKUtil.class);
    //句柄
    private static int m_nDLLHandle = -1;
    //组织机构xml长度
    private static Return_Value_Info_t nGroupLen = new Return_Value_Info_t();

    /**
     * 创建DPSDK
     */
    public static void OnCreate() {
        int nRet = -1;
        Return_Value_Info_t res = new Return_Value_Info_t();
        nRet = IDpsdkCore.DPSDK_Create(dpsdk_sdk_type_e.DPSDK_CORE_SDK_SERVER, res);
        m_nDLLHandle = res.nReturnValue;
//        if (m_nDLLHandle > 0) {
//            //设置设备状态上报监听函数
        //           nRet = IDpsdkCore.DPSDK_SetDPSDKDeviceStatusCallback(m_nDLLHandle, new DPSDKDevStatusCallback());
//            //设置NVR通道状态上报监听函数
//            nRet = IDpsdkCore.DPSDK_SetDPSDKNVRChnlStatusCallback(m_nDLLHandle, new DPSDKNVRChnlStatusCallback());
//            //设置通用JSON回调
//            nRet = IDpsdkCore.DPSDK_SetGeneralJsonTransportCallback(m_nDLLHandle, new DPSDKGeneralJsonTransportCallback());
//            //卡口过车数据回调
//            nRet = IDpsdkCore.DPSDK_SetDPSDKGetBayCarInfoCallbackEx(m_nDLLHandle, new DPSDKGetBayCarInfoCallbackEx());
//            //违章报警回调
//            nRet = IDpsdkCore.DPSDK_SetDPSDKTrafficAlarmCallback(m_nDLLHandle, new DPSDKTrafficAlarmCallback());
//            //区
//            间测速回调
//            nRet = IDpsdkCore.DPSDK_SetDPSDKGetAreaSpeedDetectCallback(m_nDLLHandle, new DPSDKGetAreaSpeedDetectCallback());
//        }
    }

    /**
     * 登录
     */

    public static void OnLogin(TbDhNvrEntity nvrEntity) {
        Login_Info_t loginInfo = new Login_Info_t();
        loginInfo.szIp = nvrEntity.getNvrIp().getBytes();
        loginInfo.nPort = nvrEntity.getPort();
        loginInfo.szUsername = nvrEntity.getUserName().getBytes();
        loginInfo.szPassword = nvrEntity.getPassword().getBytes();

        loginInfo.nProtocol = dpsdk_protocol_version_e.DPSDK_PROTOCOL_VERSION_II;
        loginInfo.iType = 1;
        int nRet = IDpsdkCore.DPSDK_Login(m_nDLLHandle, loginInfo, 10000);
        if (nRet == dpsdk_retval_e.DPSDK_RET_SUCCESS) {
            System.out.printf("登录成功，nRet = %d", nRet);
        } else {
            System.out.printf("登录失败，nRet = %d", nRet);
        }
    }

    /**
     * 加载所有组织机构树
     */
    public static void LoadAllGroup() {
        int nRet = IDpsdkCore.DPSDK_LoadDGroupInfo(m_nDLLHandle, nGroupLen, 180000);
        if (nRet == dpsdk_retval_e.DPSDK_RET_SUCCESS) {
            System.out.printf("加载所有组织树成功，nRet = %d， nGroupLen.nReturnValue = %d", nRet, nGroupLen.nReturnValue);
        } else {
            System.out.printf("加载所有组织树失败，nRet = %d", nRet);
        }
    }

    /**
     * 获取所有组织树串
     */
    public static String GetGroupStr() {
        byte[] szGroupBuf = new byte[nGroupLen.nReturnValue];
        int nRet = IDpsdkCore.DPSDK_GetDGroupStr(m_nDLLHandle, szGroupBuf, nGroupLen.nReturnValue, 10000);
        String GroupBuf = "";
        if (nRet == dpsdk_retval_e.DPSDK_RET_SUCCESS) {
            try {
                GroupBuf = new String(szGroupBuf, "UTF-8");
            } catch (IOException e) {
                System.out.println("解析所有组织树串失败");
            }
        } else {
            System.out.println("获取所有组织树串失败");
        }
        return GroupBuf;
    }

    public static int nDownloadSeq = 0;
    public static String davPath = "D:\\downoladtest.dav";
    public static fMediaDataCallback fm = new fMediaDataCallback() {
        FileOutputStream writer = null;

        public void invoke(int nPDLLHandle, int nSeq, int nMediaType,
                           byte[] szNodeId, int nParamVal, byte[] szData, int nDataLen) {
            if (nMediaType == 2 && nDataLen == 0) { //录像下载结束,开线程调用停止录像，否则接口会超时
                Thread t = new Thread(new Runnable() {

                    @Override
                    public void run() {
                        // TODO Auto-generated method stub
                        try {
                            if (writer != null) {
                                writer.flush();
                                writer.close();
                                writer = null;
                            }
                        } catch (IOException e) {
                            e.printStackTrace();
                        }

                        int nRet = IDpsdkCore.DPSDK_CloseRecordStreamBySeq(m_nDLLHandle, nDownloadSeq, 10000);
                        if (nRet == 0) {
                            nDownloadSeq = -1;
                        }
                        System.out.printf("下载结束，停止下载nRet = %d", nRet);
                        System.out.println();
                    }

                });
                t.start();
            }
            try {
                if (davPath != null) {
                    if (writer == null) {
                        writer = new FileOutputStream(davPath, true);
                    }
                    if (nDataLen > 0) {
                        writer.write(szData);
                    }
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

    };

    /**
     * 获取实时视频流
     */
    public static void getrealStream(String CamareID) {
        String m_strRealCamareID = CamareID;
        Return_Value_Info_t nRealSeq = new Return_Value_Info_t();
        Get_RealStream_Info_t getInfo = new Get_RealStream_Info_t();
        getInfo.szCameraId = m_strRealCamareID.getBytes();
        getInfo.nStreamType = dpsdk_stream_type_e.DPSDK_CORE_STREAMTYPE_MAIN;
        getInfo.nRight = dpsdk_check_right_e.DPSDK_CORE_NOT_CHECK_RIGHT;
        getInfo.nMediaType = dpsdk_media_type_e.DPSDK_CORE_MEDIATYPE_VIDEO;
        getInfo.nTransType = dpsdk_trans_type_e.DPSDK_CORE_TRANSTYPE_TCP;
        getInfo.nTrackID = 501;
        int nRet = IDpsdkCore.DPSDK_GetRealStream(m_nDLLHandle, nRealSeq, getInfo, fm, 10000);
        if (nRet == dpsdk_retval_e.DPSDK_RET_SUCCESS) {
            System.out.printf("GetRealStream success! nRet = %d, nSeq = %d", nRet, nRealSeq.nReturnValue);
        } else {
            System.out.printf("GetRealStream failed! nRet = %d", nRet);
        }
        System.out.println();
        //if (nRet == dpsdk_retval_e.DPSDK_RET_SUCCESS) {
        //    try {
        //        Thread.sleep(30000);
        //    } catch (InterruptedException e) {
        //        e.printStackTrace();
        //    }
        //    //close real stream
        //    nRet = IDpsdkCore.DPSDK_CloseRealStreamBySeq(m_nDLLHandle, nRealSeq.nReturnValue, 10000);

        //    if (nRet == dpsdk_retval_e.DPSDK_RET_SUCCESS) {
        //        System.out.printf("CloseRealStream success! nRet = %d, nSeq = %d", nRet, nRealSeq.nReturnValue);
        //    } else {
        //        System.out.printf("CloseRealStream failed! nRet = %d", nRet);
        //    }
        //    System.out.println();
        //}

    }


    /**
     * 云台方向控制.
     *
     * @param szCameraId 通道id
     * @param nDirect    控制命令 参考 dpsdk_ptz_direct_e 类
     * @param nStep      移动步数
     */
    public static int DPSDK_PtzDirection(String szCameraId, int nDirect, int nStep) {
        Ptz_Direct_Info_t directInfo = new Ptz_Direct_Info_t();
        //通道ID
        directInfo.szCameraId = szCameraId.getBytes();
        directInfo.nDirect = nDirect;
        //移动步长
        directInfo.nStep = nStep;
        //是否停止，0表示不停止，1表示停止
        directInfo.bStop = false;

        //转向调用
        return IDpsdkCore.DPSDK_PtzDirection(m_nDLLHandle, directInfo, 10000);

    }

    /**
     * 镜头控制
     *
     * @param szCameraId 通道id
     * @param nOperation 控制命令 参考 dpsdk_camera_operation_e 类
     * @param nStep      移动步数
     */
    public static int DPSDK_PtzCameraOperation(String szCameraId, int nOperation, int nStep) {
        Ptz_Operation_Info_t operation_info_t = new Ptz_Operation_Info_t();
        operation_info_t.szCameraId = szCameraId.getBytes();
        operation_info_t.nOperation = nOperation;
//        operation_info_t.nStep = 10;
        operation_info_t.nStep = nStep;
        operation_info_t.bStop = false;
        return IDpsdkCore.DPSDK_PtzCameraOperation(m_nDLLHandle, operation_info_t, 10000);
    }

    /**
     * 登出
     */
    public void OnLogout() {
        int nRet = IDpsdkCore.DPSDK_Logout(m_nDLLHandle, 10000);
        if (nRet == dpsdk_retval_e.DPSDK_RET_SUCCESS) {
            System.out.printf("登出成功，nRet = %d", nRet);
        } else {
            System.out.printf("登出失败，nRet = %d", nRet);
        }
        System.out.println();
    }

    /**
     * 释放内存
     */
    public static void OnDestroy() {
        int nRet = IDpsdkCore.DPSDK_Destroy(m_nDLLHandle);
        if (nRet == dpsdk_retval_e.DPSDK_RET_SUCCESS) {
            System.out.printf("释放内存成功，nRet = %d", nRet);
        } else {
            System.out.printf("释放内存失败，nRet = %d", nRet);
        }
        System.out.println();
    }

    /*

     */
/**
 * 获取实时视频地址
 *
 * @return
 * @throws FrameGrabber.Exception
 *//*

    public static String getRealUrl(String channelId) {
        Get_RealStreamUrl_Info_t pRealStreamUrlInfo = new Get_RealStreamUrl_Info_t();
        String m_strRealCamareID = channelId;
        pRealStreamUrlInfo.szCameraId = m_strRealCamareID.getBytes();
        pRealStreamUrlInfo.nMediaType = dpsdk_media_type_e.DPSDK_CORE_MEDIATYPE_VIDEO;
        pRealStreamUrlInfo.nStreamType = dpsdk_stream_type_e.DPSDK_CORE_STREAMTYPE_MAIN;
        pRealStreamUrlInfo.nTransType = dpsdk_trans_type_e.DPSDK_CORE_TRANSTYPE_TCP;
        int nRet = IDpsdkCore.DPSDK_GetRealStreamUrl(m_nDLLHandle, pRealStreamUrlInfo, 10000);
        if (nRet == dpsdk_retval_e.DPSDK_RET_SUCCESS) {
            String liveUrl = new String(pRealStreamUrlInfo.szUrl).trim();
            String str1 = liveUrl.substring(liveUrl.indexOf("|") + 1);
            System.out.println("===========rtsp地址========== " + str1);
            String rtsp = str1;
            FFmpegFrameGrabber grabber = null;
            try {
                grabber = FFmpegFrameGrabber.createDefault(rtsp);
            } catch (FrameGrabber.Exception e) {
                e.printStackTrace();
            }
            grabber.setOption("rtsp_transport", "tcp"); // 使用tcp的方式，不然会丢包很严重
            grabber.setImageWidth(960);
            grabber.setImageHeight(540);
            try {
                grabber.start();
            } catch (FrameGrabber.Exception e) {
                e.printStackTrace();
            }
            CanvasFrame canvasFrame = new CanvasFrame("上海永天科技测试窗口");// 创建窗口
            canvasFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);// 设置窗口关闭程序是否也跟随关闭
            canvasFrame.setAlwaysOnTop(true);
            OpenCVFrameConverter.ToMat converter = new OpenCVFrameConverter.ToMat();
            int ex = 0;
            while (true) {
                Frame frame = null;
                try {
                    frame = grabber.grabImage();
                } catch (FrameGrabber.Exception e) {
                    e.printStackTrace();
                }
                canvasFrame.showImage(frame);
            }
        } else {
            System.out.printf("获取URL失败，nRet = %d", nRet);
        }
        System.out.println();
        return null;
    }


    @PostMapping("/v1/trans-Coding")
    public Object transCoding(String link, String linkName) throws Exception {
        // 读取RTSP视频资源 传入Rtsp连接
        final FFmpegFrameGrabber grabber = new FFmpegFrameGrabber(link);
        // 设置分辨率宽度
        int captureWidth = 1280;
        grabber.setImageWidth(captureWidth);
        // 设置分辨率高度
        int captureHeight = 720;
        grabber.setImageHeight(captureHeight);
        // rtsp格式一般添加TCP配置，否则丢帧会比较严重
        // 该参数改成udp可以解决部分电脑出现的下列报警，但是丢帧比较严重 不采用
        // av_interleaved_write_frame() error -22 while writing interleaved video packet.
        grabber.setOption("rtsp_transport", "tcp");
        grabber.start();
        // 流媒体输出地址,最后一个参数是"音频AudioChannels 0:不录制,1:录制"，建议通过grabber获取
        // 地址格式为 rtmp:rtmp://{ip}:{nginx端口}/{该name为传过来的任意值}
        final FFmpegFrameRecorder recorder = new FFmpegFrameRecorder("rtmp://127.0.0.1:8012/hls/" + linkName, captureWidth, captureHeight, grabber.getAudioChannels());
        recorder.setInterleaved(true);
        // 降低编码延时
        recorder.setVideoOption("tune", "zerolatency");
        // 提升编码速度
        recorder.setVideoOption("preset", "ultrafast");
        // 视频质量参数(详见 https://trac.ffmpeg.org/wiki/Encode/H.264)
        recorder.setVideoOption("crf", "28");
        // 分辨率
        recorder.setVideoBitrate(2000000);
        // 视频编码格式
        recorder.setVideoCodec(avcodec.AV_CODEC_ID_H264);
        // 视频格式
        recorder.setFormat("flv");
        // 视频帧率
        recorder.setFrameRate(15);
        recorder.setGopSize(60);
        recorder.setAudioOption("crf", "0");
        recorder.setAudioQuality(0);
        recorder.setAudioBitrate(192000);
        recorder.setSampleRate(44100);
        // 建议从grabber获取AudioChannels
        recorder.setAudioChannels(grabber.getAudioChannels());
        recorder.setAudioCodec(avcodec.AV_CODEC_ID_AAC);
        recorder.start();

        // 解决音视频同步导致的延时问题
        Field field = recorder.getClass().getDeclaredField("oc");
        field.setAccessible(true);
        avformat.AVFormatContext oc = (avformat.AVFormatContext) field.get(recorder);
        oc.max_interleave_delta(100);

        // 用来测试的frame窗口  这个地方对应的注释释放开,可以进行代码测试
        // final CanvasFrame cFrame = new CanvasFrame("frame");
        Frame capturedFrame = null;

        // 有些时候，程序执行回报下列错误，添加一行代码解决此问题
        // av_interleaved_write_frame() error -22 while writing interleaved video packet.
        // grabber.flush();

        while (grabber.grab() != null) {
            capturedFrame = grabber.grab();
            // if (cFrame.isVisible()) {
            // 设置图像
            // cFrame.showImage(capturedFrame);
            // } else {
            // 获取每帧的编号 -- 时间戳
            System.out.println(grabber.getFrameNumber() + "--" + capturedFrame.timestamp);
            recorder.setTimestamp(capturedFrame.timestamp);
            recorder.record(capturedFrame);
            // }
        }
        // cFrame.dispose();
        recorder.close();
        grabber.close();
        return null;
    }

*/

}
