package com.usky.utils;

import org.apache.commons.lang3.StringUtils;

import java.util.Map;

/**
 * @author   辅助类
 **/
public final class MapUtils {

	/**
	 * @author
	 * @para
	 * @return string
	 **/
	public static String getStr(Object obj) {
		if (obj == null) {
			return null;
		} else {
			return StringUtils.trimToEmpty(obj.toString());
		}
	}

	/**
	 * @author   验证map设定非空字段是否为空
	 * @param params
	 *            :目标map,args:校验数组
	 * @return boolean
	 **/
	public static boolean isEmptyMap(Map<String, ?> params, String[] args) {
		if (params == null || args == null || params.isEmpty() || args.length == 0) {
			return true;
		}

		boolean bool = false;
		for (String arg : args) {
			if (StringUtils.isBlank(getStr(params.get(arg)))) {
				bool = true;
				break;
			}
		}
		return bool;
	}
	
	/**
	 * @author   判断Map是否为非NULL或者非Empty
	 * @param map
	 * @return boolean
	 * **/
	public static boolean isNotBlank(Map<String,?> map) {
		if (map != null && !map.isEmpty()) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * @author   判断Map是否为NULL或者Empty
	 * @param map
	 * @return boolean
	 * **/
	public static boolean isBlank(Map<String,?> map) {
		return !isNotBlank(map);
	}
	
	/**
	 * @author   验证map设定的value是否全是整形数值
	 * @param params
	 *            :目标map,args:校验数组
	 * @return boolean true 是, false 不是
	 **/
	public static boolean isNumericMap(Map<String, ?> params, String[] args) {
		if (params == null || args == null || params.isEmpty() || args.length == 0) {
			return false;
		}

		boolean bool = true;
		for (String arg : args) {
			if (!StringUtils.isNumeric(getStr(params.get(arg)))) {
				bool = false;
				break;
			}
		}
		return bool;
	}
}
