package com.usky.utils;

import java.util.List;

/**
 * @author laowo
 * @version v1.0
 * @date 2020/2/24 9:01
 * @description TODO
 **/
public class Page1<T> {
    private int pageSize; //每页显示条数
    private int totalCount; //总条数
    private int start; //开始条数
    private int pageNo;//当前页
    private int totalPages; //总页数
    private int peopleTotalCount; //人总数
    private int completeTotalCount; //已完成总数
    private int failedTotalCount; //审核未通过总数
    private int notReviewedTotalCount; //未审核总数
    private int unprocessedTotalCount; //未处理总数

    private List<T> pageList;//数据

    public Page1(int totalCount, Integer pageSize) {
        if (pageSize == null) {
            this.pageSize = 20;
        } else {
            this.pageSize = pageSize;
        }
        this.totalCount = totalCount;
    }

    /**
     * 获取下一条
     *
     * @return
     */
    public int getCurrentPageNo() {
        return start / pageSize + 1;
    }

    /**
     * 是否有下一条
     *
     * @return
     */
    public boolean getHasNextPage() {
        return getCurrentPageNo() < totalPages;
    }

    /**
     * 当前页是否大于一
     *
     * @return
     */
    public boolean getHasPavPage() {
        return getCurrentPageNo() > 1;
    }

    /**
     * 获取总页数
     *
     * @return
     */
    public int getTotalPages() {
        totalPages = totalCount / pageSize;

        if (totalCount % pageSize != 0) {
            totalPages++;
        }

        return totalPages;
    }

    public int getStart(int pageNo) {
        this.pageNo = pageNo;
        if (pageNo < 1) {
            pageNo = 1;
        }
        start = (pageNo - 1) * pageSize;
        return start;
    }

    public int getPageSize() {
        return pageSize;
    }

    public void setPageSize(int pageSize) {
        this.pageSize = pageSize;
    }

    public int getTotalCount() {
        return totalCount;
    }

    public void setTotalCount(int totalCount) {
        this.totalCount = totalCount;
    }

    public void setStart(int start) {
        this.start = start;
    }

    public List<T> getPageList() {
        return pageList;
    }

    public void setPageList(List<T> pageList) {
        this.pageList = pageList;
    }

    public void setTotalPages(int totalPages) {
        this.totalPages = totalPages;
    }

    public int getPageNo() {
        return pageNo;
    }

    public void setPageNo(int pageNo) {
        this.pageNo = pageNo;
    }

    public int getPeopleTotalCount() {
        return peopleTotalCount;
    }

    public void setPeopleTotalCount(int peopleTotalCount) {
        this.peopleTotalCount = peopleTotalCount;
    }

    public int getCompleteTotalCount() {
        return completeTotalCount;
    }

    public void setCompleteTotalCount(int completeTotalCount) {
        this.completeTotalCount = completeTotalCount;
    }

    public int getFailedTotalCount() {
        return failedTotalCount;
    }

    public void setFailedTotalCount(int failedTotalCount) {
        this.failedTotalCount = failedTotalCount;
    }

    public int getNotReviewedTotalCount() {
        return notReviewedTotalCount;
    }

    public void setNotReviewedTotalCount(int notReviewedTotalCount) {
        this.notReviewedTotalCount = notReviewedTotalCount;
    }

    public int getUnprocessedTotalCount() {
        return unprocessedTotalCount;
    }

    public void setUnprocessedTotalCount(int unprocessedTotalCount) {
        this.unprocessedTotalCount = unprocessedTotalCount;
    }
}
