package com.usky.utils;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Objects;

/**
 * @author laowo
 * @version v1.0
 * @date 2020/2/20 14:59
 * @description 接口统一返回结果
 **/
@ApiModel(value="统一操作结果集swagger专用")
public class ResultSwaager<T> implements Serializable {
    /** 状态码 */
    @ApiModelProperty("状态码")
    private boolean flag;//后端返回结果正常为true，发生异常返回false
    /** 状态描述 */
    @ApiModelProperty("状态描述")
    private String msg;
    /** 业务数据 */
    @ApiModelProperty("业务数据")
    private T data;

    @Override
    public String toString() {
        return "Result{" +
                "flag=" + flag +
                ", msg='" + msg + '\'' +
                ", data=" + data +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ResultSwaager result = (ResultSwaager) o;
        return flag == result.flag &&
                Objects.equals(msg, result.msg) &&
                Objects.equals(data, result.data);
    }

    @Override
    public int hashCode() {
        return Objects.hash(flag, msg, data);
    }

    public boolean isFlag() {
        return flag;
    }

    public void setFlag(boolean flag) {
        this.flag = flag;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public Object getData() {
        return data;
    }

    public void setData(T data) {
        this.data = data;
    }

    public ResultSwaager() {
    }

    public ResultSwaager(boolean flag, String msg, T data) {
        this.flag = flag;
        this.msg = msg;
        this.data = data;
    }
}